﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;


namespace Murashki
{
    abstract class Figures
    {
        protected int X, Y;
        protected int U, V;
        protected int R;
        protected Brush B;
        private Random S = new Random();

        public Figures(int x, int y, int r = 10)
        {
            X = x; Y = y; R = r;
            U = S.Next(7) - 3; V = S.Next(7) - 3;
            B = new SolidBrush
                (Color.FromArgb(S.Next(256), 0, S.Next(256)));
        }

        public abstract void Paint(Graphics g);

        public void Move(Size z)
        {
            X += U;
            if (X <= R) U = Math.Abs(U);
            if (X >= z.Width - R) U = -Math.Abs(U);

            Y += V;
            if (Y <= R) V = Math.Abs(V);
            if (Y >= z.Height - R) V = -Math.Abs(V);

        }

    } // Figures


    class Circles : Figures
    {
        public Circles(int x, int y, int r = 10)
            :base(x,y,r) 
        { 
        }

        public override void Paint(Graphics g)
        {
            g.FillEllipse(B, X - R, Y - R, 2 * R, 2 * R);
        }
    } // Circles

    class Square : Figures
    {
        public Square(int x, int y, int r = 10) : base(x, y, r) 
        { 
        }

        public override void Paint(Graphics g)
        {
            g.FillRectangle(B, X - R, Y - R, 2 * R, 2 * R);
        }
    } // Squares



}
